%author		: Georg Kuschk
%function	: Lanczos-Verfahren
%arguments	: Matrix A , maximale Anzahl Iterationsschritte k
%result		: Tridiagonalmatrix T_k

function [T_k] = lanczos(A,k);


n = size(A,1);

v_old = zeros(n,1);	%v_0 und v_1 initialisieren
x = ones(n,1);
v_new = x/norm(x,2);

beta = 0;

T_k = zeros(k,k);	%nimmt die Ergebnismatrix auf


for j = 1:k
  alpha_k = v_new'*(A*v_new);
  w_k = A*v_new - alpha_k*v_new - beta*v_old;
  beta = norm(w_k , 2);

  v_old = v_new;

  if  beta ~= 0
    v_new = w_k/beta;
  end

 %Ergebnismatrix aktualisieren
 T_k(j,j) = alpha_k;
 if j < k
   T_k(j,j+1) = beta;
   T_(j+1,j) = beta;
 end

end
