function lanczos_test(n,maxk),
if nargin==0, n=25; maxk=120; end;

% Matrix besetzen
nn=n*n;e=ones(nn,1);el=e;el(n:n:nn)=0;
A=spdiags([-e -el 4*e -[0;el(1:nn-1)] -e],[-n -1 0 1 n],nn,nn);
% exakte Vergleichswerte
Lex=4*(1+cos(pi/(n+1)));
Lex2=4*(1+cos(pi*(n)/(n+1)));

% Anfangswerte fuer Iteration. sparse erzeugt eine sparse Matrix
% fuer maxk*3 Nichtnull-Elemente. Groesse erstmal 1x1, wird
% spaeter von MATLAB automatisch vergroessert durch zuweisung
% entsprechender Elemente
T=sparse(1,1,maxk*3);
be=0;
vl=zeros(nn,1);
v=ones(nn,1)/sqrt(nn);
for k=1:maxk
   al=v'*A*v;
   w=A*v-al*v-be*vl;
   be=norm(w);
   vl=v;
   if be~=0
      v=w/be;
   end;
   T(k,k)=al;
   
   % Fehler des Eigenwerts berechnen
   err(k)=abs((max(abs(eig(T(1:k,1:k))))-Lex)/Lex);
   err2(k)=abs((min(abs(eig(T(1:k,1:k))))-Lex2)/Lex2);

   % beta-Elemente fuer naechste Iteration eintragen
   T(k+1,k)=be;
   T(k,k+1)=be;
end;
semilogy(1:maxk,err,'k-',1:maxk,err2,'--','LineWidth',2);
legend('max. Eigenwert','min. Eigenwert');

